
FORMAT: 1A
HOST: https://kashf.roshan-ai.ir

# کشف

<div dir=rtl>
کشف با دیدن نمونه‌هایی از یک مفهوم در متن، تصویر و یا ویدئو، آن را یاد می‌گیرد و می تواند در داده‌های جدید آن مفهوم را پیدا کند.
</div>

<blockquote dir=rtl>
برای دسترسی به واسط برنامه‌نویس کشف نیاز به یک TOKEN_KEY معتبر دارید که برای احراز هویت استفاده می‌شود. لطفا برای آزمایش سامانه، این متغیر را در تقاضاهای نمونه، جای‌گذاری کنید. سوال هم اگر دارید، لطفا برای آدرس kashf@roshan-ai.ir بنویسید.
</blockquote>


## تحلیل متن [/api/tag_texts/]

تابع تحلیل متن برچسب‌های مربوط به نمونه‌های ارسال شده را در یک مجموعه‌داده متنی تشخیص می‌دهد. این تابع یک مجموعه داده متنی و لیستی از متن‌ها را دریافت نموده و در پاسخ به ازای هر یک از نمونه‌ها، شناسه نمونه، متن نمونه و لیستی از برچسب‌های تشخیص داده شده را به همراه میزان اطمینان پیش‌بینی برای هر دسته ارسال می‌کند. 

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌
        - contents: list (string, required) - لیست نمونه‌های متنی ارسالی 
        - wait: true (boolean) - در صورتی که این ویژگی فعال باشد، تابع تا انجام کامل تحلیل منتظر مانده و پس از پایان فرآیند تحلیل، نتیجه را ارسال می‌کند. در صورتی که غیرفعال باشد تابع فرآیند تحلیل را آغاز کرده و تا پایان فرآیند  تحلیل، با اعلام وضعیت(‌processing)
        پاسخ می‌دهد. نتیجه تحلیل در اولین فراخوانی پس از پایان فرآیند ارسال می‌شود
        - tree_based: false (boolean) - 
    + Body

            {
                "dataset": "digikala",
                "contents": ["ارزش خریدنش رو بی شک داره", "اصلا اصلا کیفیت نداره رنگش بااین عکس زمین تاآسمون فرق داره"]
            }

+ Response 200 (application/json)

        [
          {
            "content": "ارزش خریدنش رو بی شک داره",
            "tags": [
              {
                "id": 39,
                "probability": 1.0,
                "title": "توصیه خرید"
              }
            ]
          },
          {
            "content": "اصلا اصلا کیفیت نداره رنگش بااین عکس زمین تاآسمون فرق داره",
            "tags": [
              {
                "id": 56,
                "probability": 1.0,
                "title": "عدم رضایت بعد خرید"
              }
            ]
          }
        ]


## تحلیل تصویر [/api/tag_images/]

تابع تحلیل تصویر برچسب‌های مربوط به نمونه‌ تصاویر ارسال شده را در یک مجموعه‌داده تصویری تشخیص می‌دهد. این تابع یک مجموعه داده تصویری و لیستی از تصاویر مورد سوال را دریافت کرده و در پاسخ به ازای هر یک از نمونه‌ها، شناسه نمونه، لینک تصویر و لیست برچسب‌های تشخیص داده شده را به همراه میزان اطمینان تشخیص، به صورت عددی بین صفر و یک، برای هر برچسب ارسال می‌نماید. 

### نمونه [POST]

<div dir=rtl>
می‌توانید برای همین تابع، فایل تصویر را به طور مستقیم و در قالب تقاضای <code>multipart/form-data</code> ارسال نمایید:
</div>

> curl -X POST --header "Authorization: Token TOKEN_KEY" -F "image_file=@example.jpg" -F "dataset=iran" http://kashf.roshan-ai.ir/api/tag_images

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌
        - image_urls: list (URL, required) - لیست آدرس تصاویر ارسالی برای تحلیل 
        - wait: true (boolean) - در صورتی که این ویژگی فعال باشد، تابع تا انجام کامل تحلیل منتظر مانده و پس از پایان فرآیند تحلیل، نتیجه را ارسال می‌کند. در صورتی که غیرفعال باشد تابع فرآیند تحلیل را آغاز کرده و تا پایان فرآيند تحلیل  با اعلام وضعیت(‌processing)
        پاسخ می‌دهد. نتیجه تحلیل در اولین فراخوانی پس از پایان فرآیند ارسال می‌شود.

    + Body

            {
                "dataset": "iran",
                "image_urls": ["https://media.mehrnews.com/d/2016/08/13/4/2171627.jpg", "http://teatreshahr.com/cache/51/attach/201806/254582_2927092954_1000_667.jpg"]
            }

+ Response 200 (application/json)

        [
          {
            "image_url": "https://media.mehrnews.com/d/2016/08/13/4/2171627.jpg",
            "tags": [
              {
                "id": 1,
                "probability": 1.0,
                "title": "حرم رضوی"
              }
            ]
          },
          {
            "image_url": "http://teatreshahr.com/cache/51/attach/201806/254582_2927092954_1000_667.jpg",
            "tags": [
              {
                "id": 36,
                "probability": 1.0,
                "title": "تئاتر شهر"
              }
            ]
          }
        ]


## تحلیل چهره [/api/tag_faces/]
تابع تحلیل چهره، چهره‌های تصاویر ارسال شده را در یک مجموعه‌داده چهره تشخیص می‌دهد. این تابع یک مجموعه داده چهره و لیستی از تصاویر مورد سوال را دریافت کرده و در پاسخ به ازای هر یک از نمونه‌ها، شناسه نمونه، لینک تصویر و لیست چهره‌های تشخیص داده شده را به همراه میزان اطمینان تشخیص، به صورت عددی بین صفر و یک، برای هر چهره ارسال می‌نماید. 

### نمونه [POST]

<div dir=rtl>
می‌توانید برای همین تابع، فایل تصویر را به طور مستقیم و در قالب تقاضای <code>multipart/form-data</code> ارسال نمایید:
</div>

> curl -X POST --header "Authorization: Token TOKEN_KEY" -F "image_file=@example.jpg" -F "dataset=iran" http://kashf.roshan-ai.ir/api/tag_faces

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌
        - image_urls: list (URL, required) - لیست آدرس تصاویر ارسالی برای تحلیل 
        - wait: true (boolean) - در صورتی که این ویژگی فعال باشد، تابع تا انجام کامل تحلیل منتظر مانده و پس از پایان نتیجه را ارسال می‌کند. در صورتی که غیرفعال باشد تابع فرآیند تحلیل را آغاز کرده و تا پایان تحلیل بلافاصله با اعلام وضعیت(‌processing)
        پاسخ می‌دهد. نتیجه تحلیل در اولین فراخوانی پس از پایان تحلیل ارسال می‌شود

    + Body

            {
                "dataset": "faces",
                "image_urls": ["https://media.mehrnews.com/d/2021/12/26/3/4002104.jpg"]
            }

+ Response 200 (application/json)

        [
          {
            "image_url": "https://media.mehrnews.com/d/2016/08/13/4/2171627.jpg",
            "tags": [
              {
                "id": 328742,
                "probability": 1.0,
                "title": "حسین امیرعبداللهیان (سیاسی)"
              }
            ]
          }
        ]


## تحلیل فریم‌های ویدئو [/api/tag_video_frames/]

این تابع برای تحلیل فریم‌های یک ویدئو و تشخیص برچسب‌های مربوط به هر فریم در یک مجموعه داده مشخص کاربرد دارد. ابن تابع مجموعه داده مربوطه و لیست آدرس‌های مربوط به ویدئو‌ها را دریافت کرده و در پاسخ لیستی از فریم‌های استخراج شده، شامل شماره، برچسب زمانی و لیستی از برچسب‌های تشخیص داده شده به همراه میزان اطمینان از هر برچسب را ارسال می‌نماید.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌
        - video_urls: list (URL, required) - لیست آدرس ویدئوهای ارسالی برای تحلیل فریم‌ها 
        - every_ms: 100 (number) - فاصله بین فریم‌های استخراج شده برای تحلیل بر مبنای میلی ثانیه
        - min_frame_diff: 0.4 (number) - حداقل مقدار تفاوت دو فریم که بیش از آن، دو فریم متفاوت در نظر گرفته می‌شوند.
        - duration: null (number) - مقدار ثانیه‌‌ای از ابتدای ویدئو که مورد پردازش قرار می‌گیرد. اگر این ویژگی null باشد کل ویدئو پردازش می‌شود.
        - wait: true (boolean) - در صورتی که این ویژگی فعال باشد، تابع تا انجام کامل تحلیل منتظر مانده و پس از پایان نتیجه را ارسال می‌کند. در صورتی که غیرفعال باشد تابع فرآیند تحلیل را آغاز کرده و تا پایان فرآیند تحلیل، با اعلام وضعیت(‌processing)
        پاسخ می‌دهد. نتیجه تحلیل در اولین فراخوانی پس از پایان فرآیند ارسال می‌شود
    + Body

            {
                "dataset": "iran",
                "every_ms": 50,
                "duration": 25,
                "min_frame_diff": 0.40,
                "video_urls": ["https://hw15.cdn.asset.aparat.com/aparat-video/98b7e4cc00c97dffde2ae00567b98a4312759670-480p__79959.mp4"]
            }

+ Response 200 (application/json)

        [
          {
            "video_url": "https://hw15.cdn.asset.aparat.com/aparat-video/98b7e4cc00c97dffde2ae00567b98a4312759670-480p__79959.mp4",
            "frames": [
              {
                "frame": 3,
                "time": "0:00:00",
                "tags": [
                  {
                    "id": 0,
                    "probability": 1.0,
                    "title": "ناآشنا"
                  }
                ]
              },
              {
                "frame": 585,
                "time": "0:00:23",
                "tags": [
                  {
                    "id": 39127,
                    "probability": 0.99,
                    "title": "پل طبیعت"
                  }
                ]
              },
              {
                "frame": 603,
                "time": "0:00:24",
                "tags": [
                  {
                    "id": 2,
                    "probability": 1.0,
                    "title": "میدان آزادی"
                  }
                ]
              }
            ]
          }
        ]


## تحلیل چهره‌های ویدئو [/api/tag_video_faces/]

این تابع برای تحلیل فریم‌های یک ویدئو و تشخیص چهره‌ها در ویدئو  کاربرد دارد. ابن تابع مجموعه داده مربوطه و لیست آدرس‌های مربوط به ویدئو‌ها را دریافت کرده و در پاسخ لیستی از فریم‌های استخراج شده، شامل شماره، برچسب زمانی و لیستی از چهره‌های تشخیص داده شده به همراه میزان اطمینان از هر دسته را ارسال می‌نماید.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌
        - video_urls: list (URL, required) - لیست آدرس ویدئوهای ارسالی برای تحلیل فریم‌ها 
        - every_ms: 100 (number) - فاصله بین فریم‌های استخراج شده برای تحلیل بر مبنای میلی ثانیه
        - min_frame_diff: 0.4 (number) - حداقل مقدار تفاوت دو فریم که بیش از آن، دو فریم متفاوت در نظر گرفته می‌شوند.
        - duration: 25 (number) - مقدار ثانیه‌‌ای از ابتدای ویدئو که مورد پردازش قرار می‌گیرد. اگر این ویژگی null باشد کل ویدئو پردازش می‌شود.
        - wait: true (boolean) - در صورتی که این ویژگی فعال باشد، تابع تا انجام کامل تحلیل منتظر مانده و پس از پایان فرآيند تحلیل، نتیجه را ارسال می‌کند. در صورتی که غیرفعال باشد تابع فرآیند تحلیل را آغاز کرده و تا پایان فرآيند تحلیل، با اعلام وضعیت(‌processing)
        پاسخ می‌دهد. نتیجه تحلیل در اولین فراخوانی پس از پایان فرآیند ارسال می‌شود

    + Body

            {
                "dataset": "faces",
                "every_ms": 50,
                "duration": 25,
                "min_frame_diff": 0.40,
                "video_urls": ["https://hajifirouz6.cdn.asset.aparat.com/aparat-video/00f33274de87f86afa23a330880e25f042720646-240p.mp4"]
            }

+ Response 200 (application/json)



## تحلیل ویدئو [/api/tag_videos/]

تابع تحلیل ویدئو، برچسب‌های مربوط به نمونه‌ ویدئوهای ارسال شده را در یک مجموعه‌داده ویدئویی تشخیص می‌دهد. این تابع یک مجموعه داده ویدئویی و لیستی از آدرس ویدئوهای مورد سوال را دریافت کرده و در پاسخ به ازای هر یک از نمونه‌ها، شناسه نمونه، لینک ویدئو و لیست برچسب‌های تشخیص داده شده را به همراه میزان اطمینان تشخیص، به صورت عددی بین صفر و یک، برای هر برچسب ارسال می‌نماید. 

### نمونه [POST]


> curl -X POST --header "Authorization: Token TOKEN_KEY" -F "image_file=@example.jpg" -F "dataset=iran" http://kashf.roshan-ai.ir/api/tag_videos

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌
        - video_urls: list (URL, required) - لیست آدرس ویدئوهای ارسالی برای تحلیل 
        - wait: true (boolean) - در صورتی که این ویژگی فعال باشد، تابع تا انجام کامل تحلیل منتظر مانده و پس از پایان فرآیند تحلیل، نتیجه را ارسال می‌کند. در صورتی که غیرفعال باشد تابع فرآیند تحلیل را آغاز کرده و تا پایان فرآیند،  با اعلام وضعیت(‌processing)
        پاسخ می‌دهد. نتیجه تحلیل در اولین فراخوانی پس از پایان فرآیند ارسال می‌شود

    + Body

            {
                "dataset": "aparat",
                "video_urls": ["https://hajifirouz2.cdn.asset.aparat.cloud/aparat-video/ecf1d6ea175858e4c3bf54585c583e2342171585-240p.mp4"]
            }

+ Response 200 (application/json)

        [
          {
            "image_url": "https://hajifirouz2.cdn.asset.aparat.cloud/aparat-video/ecf1d6ea175858e4c3bf54585c583e2342171585-240p.mp4",
            "tags": [
              {
                "id": 77,
                "probability": 1.0,
                "title": "بسکتبال"
              }
            ]
          }
        ]


## آموزش مدل [/api/train_dataset/]
با فراخوانی این تابع فرآیند آموزش مدل یادگیری ماشین روی مجموعه داده مشخص شده آِغاز می‌شود. خروجی تابع وضعیت آموزش را نمایش می‌دهد که در حالت عادی waiting می‌باشد. وضعیت waiting نشان می‌دهد فرآیند آموزش هنوز شروع نشده و منتظر تخصیص منابع و شروع فرآیند است.
برای مشاهده روند و وضعیت فرآیند آموزش و از تابع وضعیت داده استفاده کنید.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    +Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده مورد نظر برای آموزش مدل
    + Body

            {
                "dataset": "iran"
            }

+ Response 200 (application/json)

        {
            "dataset": "iran",
            "state": "waiting"
        }


## بازبینی مدل [/api/retag_dataset/]
با فراخوانی این تابع فرآیند بازبینی داده‌های موجود در مجموعه داده آغاز می‌شود. در فرآیند بازبینی سامانه با استفاده از مدل یادگیری ماشین مجددا تعدادی از داده‌ها را برچسب می‌زند. این تابع معمولا بعد از آموزش مدل جدید کاربرد دارد که با بازبینی داده‌ها، برچسب‌های برخی از نمونه‌ها تغییر می‌کنند. در این تابع حداکثر تعداد نمونه‌هایی که در این فرآیند بازبینی می‌شوند به عنوان پارامتر ارسال می‌شود. اگر تعداد نمونه‌های مجموعه داده کمتر از این مقدار باشد، تمامی نمونه‌ها بازبینی می‌شوند.
خروجی تابع وضعیت فرآیند را نشان می‌دهد که در حالت عادی waiting می‌باشد. براب مشاهده روند فرآیند و بررسی وضعیت آن، از فراخوانی تابع وضعیت داده استفاده نمایید.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    +Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده مورد نظر برای آموزش مدل
        - max_predictions: maximum retags (number, required) - حداکثر تعداد نمونه‌هایی بازبینی شوند
    + Body

            {
                "dataset": "iran",
                "max_predictions": 100
            }

+ Response 200 (application/json)

        {
            "dataset": "iran",
            "state": "waiting"
        }

## دریافت مجموعه داده [/api/export_dataset/]
این تابع برای دریافت مجموعه داده در قالب یک فایل csv می‌باشد.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    +Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده مورد نظر برای آموزش مدل
        - original_urls: (boolean) - اگر این ویژگی فعال باشد، آدرس‌های اصلی تصاویر و یا ویدئوها در فایل قرار می‌گیرند و در غیر این صورت، آدرس نمونه داخل سرور کشف در فایل گذاشته می‌شود.
        - tag_names: (boolean) - اگر این ویژگی فعال باشد نام عناوین به عنوان برچسب انتخاب می‌شوند و در غیر این صورت شناسه‌ها به عنوان برچسب قرار داده می‌شوند.

    + Body

            {
                "dataset": "iran",
                "original_urls": true,
                "tag_names": true
            }

+ Response 200 (application/json)

        {
            "dataset": "iran",
            "state": "waiting"
        }

## وارد کردن داده [/api/export_dataset/]
این تابع برای وارد کردن داده‌ها در قالب فایل csv و اضافه کردن آن‌ها به مجموعه داده می‌باشد.

### نمونه [POST]

<div dir=rtl>
می‌توانید برای همین تابع، فایل داده را به طور مستقیم و در قالب تقاضای <code>multipart/form-data</code> ارسال نمایید:
</div>

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    +Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده مورد نظر برای آموزش مدل
        - csv_url: imported file URL (string, required) -  آدرس فایل حاوی داده مربوطه
        - report_items: (boolean) - اگر این ویژگی فعال باشد، تمامی نمونه‌های موجود در فایل به عنوان گزارش در برچسب مربوطه اضافه می‌شوند.
        - tag_names: (boolean) - اگر این ویژگی فعال باشد نام عناوین به عنوان برچسب انتخاب می‌شوند و در غیر این صورت شناسه‌ها به عنوان برچسب قرار داده می‌شوند.

    + Body

            {
                "dataset": "iran",
                "report_items": true,
                "tag_names": true
            }

+ Response 200 (application/json)

        {
            "dataset": "iran",
            "state": "waiting"
        }


## وضعیت داده‌ها [/api/dataset_info/]
این تابع اطلاعاتی از وضعیت داده‌ها و فرآیندهای آموزش و ارزیابی را در  مجموعه داده مشخص شده ارسال می‌نماید. این اطلاعات شامل موارد زیر هستند:
+ وضعیت فرآیند آموزش و ارزیابی مجموعه داده
+ تعداد کل نمونه‌ها
+ تعداد کل نمونه‌های گزارش شده
+ نتایج ارزیابی مدل آموزش داده شده روی مجموعه داده 
+ اطلاعات داده و ارزیابی مربوط به هر کدام از دسته‌ها (در صورت فعال بودن ویژگی tags)

وضعیت‌هایی ممکن مجموعه داده:
+ waiting: در این حالت مجموعه داده منتظر دریافت منابع و شروع فرآیند می‌باشد. 
+ training: فرآیند آموزش مدل یادگیری ماشین در حال انجام است.
+ trained: آموزش مدل پایان یافته و مدل جدید آماده شده است.
+ retagging: فرایند بازبینی داده‌ها در حال انجام است
+ retagged: بازبینی داده‌ها پایان یافته و نتایج ارزیابی به روز شده است.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset:  dataset slug (string, required) - نام مجموعه داده مورد نظر برای دریافت اطلاعات وضعیت
        - tags: true (boolean) - اگر این ویژگی فعال باشد، اطلاعات مربوط به وضعیت داده و ارزیابی تک تک برچسب‌های موجود در مجموعه داده ارسال می‌شود.

    + Body

            {
                "dataset": "iran",
                "tags": true
            }

+ Response 200 (application/json)

        {
          "title": "لحظه",
          "state": "trained",
          "report_count": 935,
          "data_count": 2404,
          "evaluation": {
            "recall": 87,
            "precision": 91
          },
          "tags": [
            {
              "title": "برج میلاد"
              "id": 3,
              "reports": 116,
              "predictions": 156,
              "evaluation": {
                "recall": 80.3,
                "precision": 91.4,
                "f1": 86.0
              },
            },
            ...
          ]
        }


## گزارش برچسب متن [/api/report_text_tags/]
وظیفه این تابع افزودن گزارش به برچسب‌ها می‌باشد. یک گزارش نمونه‌ای است که تعلق و یا عدم تعلق به یک برچسب از قبل در آن مشخص شده و سامانه با استفاده از این گزارش‌ها مدل یادگیری ماشین را آموزش می‌دهد. این تابع یک نمونه متنی را در مجموعه داده متنی مشخص شده و در برچسب مشخص شده گزارش می‌کند. این گزارش می‌تواند مثبت (‌نمونه متعلق به برچسب است) و یا منفی (نمونه متلعق به برچسب نیست) باشد.  خروجی این تابع شامل لیستی از آیتم‌هاست که هر آیتم شناسه گزارش مربوط به همراه یک دوتایی شامل شناسه برچسب و مثبت یا منفی بودن گزارش را مشخص می‌کند.
### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - content: (string, required) - متن نمونه گزارش شده
        - tag_id: (number, required) - شناسه برچسب مورد نظر برای گزارش 
        - positive: true (boolean) -  این ویژگی بیانگر مثبت (تعلق نمونه به برچسب) و یا منفی (عدم تعلق نمونه به برچسب) است

    + Body

            [
              {
                "content": "پیشنهاد میکنم از این بخرید خیلی عالیه.",
                "tag_id": 39,
                "positive": true
              }
            ]

+ Response 200 (application/json)

        [
          {
            "report": "[[39,true]]",
            "id": 1211592
          }
        ]



## گزارش برچسب تصویر [/api/report_image_tags/]
وظیفه این تابع افزودن گزارش به برچسب‌ها می‌باشد. یک گزارش  تعلق و یا عدم تعلق یک نمونه را به یک برچسب مشخص می‌کند و سامانه با استفاده از گزارش‌ها مدل یادگیری ماشین را آموزش می‌دهد. این تابع یک تصویر را در مجموعه داده تصویری مشخص شده و در دسته مشخص شده گزارش می‌کند. این گزارش می‌تواند مثبت (‌نمونه متعلق به دسته است) و یا منفی (نمونه متلعق به دسته نیست) باشد.  خروجی این تابع شمال لیستی از آیتم‌هاست که هر آیتم شناسه گزارش مربوط به همراه یک دوتایی شامل شناسه دسته و مثبت یا منفی بودن گزارش را مشخص می‌کند.
### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes
        - image_url: URL (string, required) - آدرس تصویر گزارش شده
        - tag_id: (number, required) - شناسه برچسب مورد نظر برای گزارش 
        - positive: true (boolean) -  این ویژگی بیانگر مثبت (تعلق نمونه به برچسب) و یا منفی (عدم تعلق نمونه به برچسب) است

    + Body

            [
              {
                "image_url": "https://upload.wikimedia.org/wikipedia/fa/thumb/5/54/Tehran-Milad_Tower2.jpg/800px-Tehran-Milad_Tower2.jpg",
                "tag_id": 3,
                "positive": true
              }
            ]

+ Response 200 (application/json)

        [
          {
            "report": "[[3,true]]",
            "id": 1211593
          }
        ]


## حذف گزارش[/api/remove_tag_report/]
این تابع یک گزارش موجود را حذف می‌کند. برای حذف گزارش تابع شناسه گزارش و شناسه برچسب را به عنوان ورودی می‌گیرد. برای حذف گزارش متنی شناسه متن با عنوان text_id و برای حذف گزارش تصویری شناسه تصویر با عنوان image_id ارسال می‌شود.
### نمونه [POST]

+ Request (application/json)

    + Headers
            Authorization: Token TOKEN_KEY

    + Attributes
        - text_id: (number) - آدرس متن گزارش شده
        - image_id: (number) - آدرس تصویر گزارش شده
        - tag_id: (number, required) - شناسه برچسب مورد نظر برای گزارش 

    + Body
        {
          "image_id": 1211593,
          "tag_id": 3,
        }

+ Response 200 (application/json)
        {
          "image_id": 1211593,
          "tag_id": 3,
        }
        


## ایجاد برچسب [/api/create_tag/]
این تابع وظیفه ایجاد برچسب جدید در یک مجموعه داده را دارد. برای این کار عنوان برچسب و همچنین مجموعه داده‌ای که برچسب در آن باید ساخته شود به عنوان ورودی به تابع داده می‌شود. همچنین در تنظیمات ارسالی به تابع می‌توان مشخص کرد که برچسب ساخته شده فعال یا غیرفعال باشد. در صورتی که یک برچسب غیرفعال باشد، گزارش‌های مربوط به آن برچسب در فرآیند آموزش و ارزیابی شرکت داده نمی‌شود و در نتیجه مدل نیز این برچسب را آموزش نمی‌بیند.
### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده‌ای که برچسب جدید در آن ساخته می‌شود
        - title: (string, required) - عنوان برچسب
        - positive: true (boolean) -  این ویژگی بیانگر فعال یا غیر فعال بودن برچسب در مجموعه داده است. در صورتی که یک برچسب غیرفعال باشد، گزارش‌های مربوط به آن برچسب در فرآیند آموزش و ارزیابی شرکت داده نمی‌شود و در نتیجه مدل نیز این برچسب را آموزش نمی‌بیند.

    + Body

            {
              "dataset": "iran",
              "title": "New Place"
            }

+ Response 200 (application/json)

        {
          "title": "New Place",
          "tag_id": 111111111,
          "active": true
        }


## ویرایش برچسب [/api/update_tag/]
این تابع برای ویرایش اطلاعات و مشخصات مربوط به یک برچسب موجود کاربرد دارد. با استفاده از این تابع می‌توان نام برچسب، مجموعه داده‌ای که برچسب متعلق به آن است و وضعیت برچسب (فعال یا غیر فعال) را ویرایش نمود.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes
        - tag_id: tad id (number, required) - شناسه برچسب
        - dataset: dataset slug (string, required) - نام مجموعه داده‌ای صاحب برچسب
        - title: (string, required) - عنوان برچسب
        - positive: true (boolean) -  این ویژگی بیانگر فعال یا غیر فعال بودن برچسب در مجموعه داده است. در صورتی که یک برچسب غیرفعال باشد، گزارش‌های مربوط به آن برچسب در فرآیند آموزش و ارزیابی شرکت داده نمی‌شود و در نتیجه مدل نیز این برچسب را آموزش نمی‌بیند.

    + Body

            {
              "dataset": "iran",
              "tag_id": 111111111,
              "title": "Old Place",
              "active": true
            }

+ Response 200 (application/json)

        {
          "title": "Old Place",
          "tag_id": 111111111,
          "active": true
        }


## حذف برچسب [/api/delete_tag/]
این تابع یک برچسب را حذف می‌کند. با حذف یک برچسب تمامی گزارش‌های مربوط به آن نیز حذف می‌گردد. این تابع شناسه برچسب مورد نظر برای حذف را به عنوان ورودی دریافت کرده و در پاسخ مجموعه داده صاحب برچسب و تعداد گزارش‌های پاک شده از این مجموعه داده را ارسال می‌کند. 
### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - tag_id: tad id (number, required) - شناسه برچسب

    + Body

            {
              "tag_id": 111111111
            }

+ Response 200 (application/json)

        {
          "dataset": "iran",
          "deleted_reports": 0
        }

## تشخیص‌های یک برچسب [/api/list_tag_predictions/]
 این تابع، لیستی حداکثر ۵۰ تایی از تشخیص‌های مدل در برچسب مربوطه ارسال می‌کند. نمونه‌های به صورت صفحه بندی شده ارسال می‌شود که می‌توان با پارامتر page در url صفحه مورد نظر را فراخوانی کرد.
 برای فراخوانی این تابع نیاز به مشخص کردن مجموعه داده و شناسه برچسب مورد نظر می‌باشد.

### نمونه [POST]
+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - tag_id: tad id (number, required) - شناسه برچسب

    + Body

            {
              "dataset": "iran"
              "tag_id": 2
            }

+ Response 200 (application/json)
        {
          count: 111
          next: "[base_url]/api/list_tag_predictions/?page=2"
          previous: null
          results: [{id: 1385,…}, {id: 1873984,…},…]
        }

        
## گزارش‌های یک برچسب [/api/list_tag_reports/]
 این تابع، لیستی حداکثر ۵۰ تایی از گزارش‌های برچسب مربوطه را ارسال می‌کند.  نمونه‌های به صورت صفحه بندی شده ارسال می‌شود که می‌توان با پارامتر page در url صفحه مورد نظر را فراخوانی کرد.
 برای فراخوانی این تابع نیاز به مشخص کردن مجموعه داده و شناسه برچسب مورد نظر می‌باشد.
با استفاده از پارامتر reported_positive امکان فیلتر کردن گزارش‌های مثبت یا منفی وجود دارد.
### نمونه [POST]
+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - tag_id: tad id (number, required) - شناسه برچسب
        - reported_positive: None (boolean) - اگر این ویژگی فعال باشد تنها گزارش‌های مثبت ارسال می‌شود و اگر غیر فعال باشد تنها گزارش‌های منفی ارسال می‌شود. اگر این ویژگی None باشد همه گزارش‌های ارسال می‌شود. مقدار پیش‌فرض این ویژگی None است.
    + Body

            {
              "dataset": "iran"
              "tag_id": 2
            }

+ Response 200 (application/json)
        {
          count: 201
          next: "[base_url]/api/list_tag_reports/?page=2"
          previous: null
          results: [{image: {id: 1832, url: "http://cdn-tehran.wisgoon.com/dlir-s3/10531458126211291615.jpg",…},…},…]
        }


## گزارش‌های مشکوک یک برچسب [/api/list_notsure_reports_list/]
 این تابع، لیستی حداکثر ۵۰ تایی از گزارش‌های برچسب مربوطه که مدل به برچسب آن مشکوک است را ارسال می‌کند. گزارش مشکوک در واقع گزارشی است که برچسب تشخیصی مدل با برچسب گزارش شده برای نمونه متفاوت باشد. نمونه‌ها به صورت صفحه بندی شده ارسال می‌شود که می‌توان با پارامتر page در url صفحه مورد نظر را فراخوانی کرد.
 برای فراخوانی این تابع نیاز به شناسه برچسب مورد نظر می‌باشد.
با استفاده از پارامتر reported_positive امکان فیلتر کردن گزارش‌های مثبت یا منفی وجود دارد.
### نمونه [POST]
+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
    
    + Attributes
        - tag_id: tad id (number, required) - شناسه برچسب
        - reported_positive: None (boolean) - اگر این ویژگی فعال باشد تنها گزارش‌های مثبت ارسال می‌شود و اگر غیر فعال باشد تنها گزارش‌های منفی ارسال می‌شود. اگر این ویژگی None باشد همه گزارش‌های ارسال می‌شود. مقدار پیش‌فرض این ویژگی None است.

    + Body
            {
              "tag_id": 2
            }

+ Response 200 (application/json)
        {
          count: 201
          next: "[base_url]/api/list_tag_reports/?page=2"
          previous: null
          results: [{image: {id: 1832, url: "http://cdn-tehran.wisgoon.com/dlir-s3/10531458126211291615.jpg",…},…},…]
        }

## مجموعه داده‌ها [/api/list_datasets/]
با فراخوانی این تابع لیستی از مجموعه داده‌هایی که کاربر امکان مشاهده و دسترسی به آن‌ها را دارد دریافت می‌شود. 

### نمونه [GET]
+ Request
    + Headers
            Authorization: Token TOKEN_KEY
  
+ Response 200 (application/json)
        [{
            'title': "ایران",
            'type': "image-tag",
            'slug': "iran",
            'tag_count': 21,
            'report_count': 2526,
            'state': "trained",
            'evaluation': {"precision": 0.94 , "recall": 0.87},
            'trained_at': ""
          }, ...]


## نمونه‌های متنی یک مجموعه  [/api/list_texts/]
این تابع با دریافت نام مجموعه داده و لیستی از شناسه‌ نمونه‌های، در پاسخ اطلاعات نمونه‌های مربوطه را ارسال می‌نماید.

### نمونه [POST]
+ Request
    + Headers
            Authorization: Token TOKEN_KEY

    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - text_ids: list (number, required) - لیستی از شناسه نمونه‌ها

    + Body

        {
          "dataset": "persica",
          "text_ids": [11462988]
        }

+ Response 200 (application/json)
        [{
            count: 234
            results: [{text: {id: 11462988,…},…}] 
          }, ...]

## نمونه‌های تصویری یک مجموعه  [/api/list_images/]
این تابع با دریافت نامه مجموعه داده و لیستی از شناسه‌ نمونه‌های، در پاسخ اطلاعات نمونه‌های مربوطه را ارسال می‌نماید.

### نمونه [POST]
+ Request
    + Headers
            Authorization: Token TOKEN_KEY

    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - images_ids: list (number, required) - لیستی از شناسه نمونه‌ها
 
    + Body
        {
          "dataset": "iran",
          "text_ids": [1832]
        } 

+ Response 200 (application/json)
        {
          count: 201
          results: [{image: {id: 1832, url: "http://cdn-tehran.wisgoon.com/dlir-s3/10531458126211291615.jpg",…}]
        }


## جستجو در نمونه‌های متنی  [api/search_candidate_texts/]
برای جستجو در متن‌های موجود در یک مجموعه داده متنی از این تابع استفاده می‌شود. این تابع مجموعه داده متنی مورد نظر و عبارت جستجو را دریافت کرده و در پاسخ متن‌های شامل عبارت در مجموعه داده را ارسال می‌نماید.
این تابع امکان جستجو در نمونه‌های گزارش نشده و یا نمونه‌های گزارش شده را فراهم می‌کند.
نتایج جستجو به صورت صفحه‌بندی شده و در لیست‌های حداکثر ۵۰ تایی ارسال می‌شود.

### نمونه [POST]
+ Request
    + Headers
            Authorization: Token TOKEN_KEY

    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - query: None (string, required) - عبارت جستجو
        - reported: false (boolean) - اگر این ویژگی فعال باشد تنها در نمونه‌های گزارش شده جستجو انجام می‌شود و در غیر این صورت در نمونه‌های گزارش نشده جستجو صورت می‌گیرد.
        - tag_id: (number) - گزارش‌ها در ویژگی reported بر مبنای این ویژگی در نظر گرفته می‌شود. در واقع در صورتی که reported فعال باشد جستجو در گزارش‌های مربوط به این شناسه برچسب انجام می‌شود.

    + Body
        {
          dataset: "persica",
          query: "اقتصاد مثاومتی",
          tag_id: 1482,
          reported: false         
        }
        

+ Response 200 (application/json)
        {
          count: 10
          next: null
          previous: null
          results: [{id: 11462939,…}, {id: 4446967,…}, {id: 4444533,…}, {id: 4444455,…}, {id: 4444260,…}, {id: 4444137,…},…]
        }


## جستجو در نمونه‌های تصویری  [api/search_candidate_images/]
با استفاده از این تابع می‌توان در نمونه‌های تصویری یک مجموعه داده تصویری جستجو انجام داد.
نتایج به صورت صفحه بندی شده و در لیست‌های حداکثر ۵۰ تایی ارسال می‌شود.

### نمونه [POST]
+ Request
    + Headers
            Authorization: Token TOKEN_KEY

    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - query: None (string, required) - عبارت جستجو
        - tag_id: (number) - شناسه برچسب مورد نظر

    + Body
        {
          dataset: "iran",
          query: "برج آزادی",
          tag_id: 2
        }
        

+ Response 200 (application/json)
        {
          count: 10
          next: null
          previous: null
          results: [{id: 11462939,…}, {id: 4446967,…}, {id: 4444533,…}, {id: 4444455,…}, {id: 4444260,…}, {id: 4444137,…},…]
        }


## جستجو در نمونه‌های متنی  [api/search_candidate_faces/]
با استفاده از این تابع می‌توان در تصاویر چهره‌ها جستجو انجام داد.

### نمونه [POST]
+ Request
    + Headers
            Authorization: Token TOKEN_KEY

    + Attributes
        - dataset: dataset slug (string, required) - نام مجموعه داده
        - query: None (string, required) - عبارت جستجو
        - tag_id: (number) - شناسه برچسب مورد نظر

    + Body
        {
          dataset: "faces",
          query: " احسان کرمی",
          tag_id: 213243
        }

+ Response 200 (application/json)
        {"items":[{"url":"https://static1.neshanonline.com/thumbnail/yVTNvWR9IHxN/gK8fHXfDXrqfbFZCqByYQnf9bgWP7DnqxIBUmuF8jDF1YIE8vRbA5t0DEhHhnmOX/Untitled.jpg","width":null,"height":null,"data":{},"processed":null}, ...],"count":76}